/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIBufferInputStream.idl
 */

#ifndef __gen_nsIBufferInputStream_h__
#define __gen_nsIBufferInputStream_h__

#include "nsIInputStream.h"

class nsIBuffer; /* forward declaration */

/**
 * The signature of the writer function passed to ReadSegments. This
 * specifies where the data should go that gets read from the buffer.
 * Implementers should return the following:
 * @return NS_OK and writeCount - if successfully wrote something
 * @return NS_BASE_STREAM_CLOSED - if no more can be written
 * @return NS_BASE_STREAM_WOULD_BLOCK - if there is currently space to write (in
 *   a non-blocking mode)
 * @return <other-error> - on failure
 */
typedef NS_CALLBACK(nsWriteSegmentFun)(void* closure,
                                       const char* fromRawSegment,
                                       PRUint32 toOffset,
                                       PRUint32 count,
                                       PRUint32 *writeCount);

/* starting interface:    nsIBufferInputStream */
#define NS_IBUFFERINPUTSTREAM_IID_STR "93e9a230-1955-11d3-933b-000064657374"

#define NS_IBUFFERINPUTSTREAM_IID \
  {0x93e9a230, 0x1955, 0x11d3, \
    { 0x93, 0x3b, 0x00, 0x00, 0x64, 0x65, 0x73, 0x74 }}

class nsIBufferInputStream : public nsIInputStream {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IBUFFERINPUTSTREAM_IID)

  /**
     * Returns the buffer underlying this input stream.
     */
  /* readonly attribute nsIBuffer Buffer; */
  NS_IMETHOD GetBuffer(nsIBuffer * *aBuffer) = 0;

  /* [noscript] unsigned long ReadSegments (in nsWriteSegmentFun writer, in voidPtr closure, in unsigned long count); */
  NS_IMETHOD ReadSegments(nsWriteSegmentFun writer, void * closure, PRUint32 count, PRUint32 *_retval) = 0;

  /**
     * Searches for a string in the input stream. Since the stream has a notion
     * of EOF, it is possible that the string may at some time be in the 
     * buffer, but is is not currently found up to some offset. Consequently,
     * both the found and not found cases return an offset:
     *    if found, return offset where it was found
     *    if not found, return offset of the first byte not searched
     * In the case the stream is at EOF and the string is not found, the first
     * byte not searched will correspond to the length of the buffer.
     */
  /* void Search (in string forString, in boolean ignoreCase, out boolean found, out unsigned long offsetSearchedTo); */
  NS_IMETHOD Search(const char *forString, PRBool ignoreCase, PRBool *found, PRUint32 *offsetSearchedTo) = 0;

  /**
     * Set this attribute to put the stream in non-blocking mode.
     */
  /* attribute boolean NonBlocking; */
  NS_IMETHOD GetNonBlocking(PRBool *aNonBlocking) = 0;
  NS_IMETHOD SetNonBlocking(PRBool aNonBlocking) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIBUFFERINPUTSTREAM \
  NS_IMETHOD GetBuffer(nsIBuffer * *aBuffer); \
  NS_IMETHOD ReadSegments(nsWriteSegmentFun writer, void * closure, PRUint32 count, PRUint32 *_retval); \
  NS_IMETHOD Search(const char *forString, PRBool ignoreCase, PRBool *found, PRUint32 *offsetSearchedTo); \
  NS_IMETHOD GetNonBlocking(PRBool *aNonBlocking); \
  NS_IMETHOD SetNonBlocking(PRBool aNonBlocking); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIBUFFERINPUTSTREAM(_to) \
  NS_IMETHOD GetBuffer(nsIBuffer * *aBuffer) { return _to ## GetBuffer(aBuffer); } \
  NS_IMETHOD ReadSegments(nsWriteSegmentFun writer, void * closure, PRUint32 count, PRUint32 *_retval) { return _to ## ReadSegments(writer, closure, count, _retval); } \
  NS_IMETHOD Search(const char *forString, PRBool ignoreCase, PRBool *found, PRUint32 *offsetSearchedTo) { return _to ## Search(forString, ignoreCase, found, offsetSearchedTo); } \
  NS_IMETHOD GetNonBlocking(PRBool *aNonBlocking) { return _to ## GetNonBlocking(aNonBlocking); } \
  NS_IMETHOD SetNonBlocking(PRBool aNonBlocking) { return _to ## SetNonBlocking(aNonBlocking); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsBufferInputStream : public nsIBufferInputStream
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIBUFFERINPUTSTREAM

  nsBufferInputStream();
  virtual ~nsBufferInputStream();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsBufferInputStream, nsIBufferInputStream)

nsBufferInputStream::nsBufferInputStream()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsBufferInputStream::~nsBufferInputStream()
{
  /* destructor code */
}

/* readonly attribute nsIBuffer Buffer; */
NS_IMETHODIMP nsBufferInputStream::GetBuffer(nsIBuffer * *aBuffer)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] unsigned long ReadSegments (in nsWriteSegmentFun writer, in voidPtr closure, in unsigned long count); */
NS_IMETHODIMP nsBufferInputStream::ReadSegments(nsWriteSegmentFun writer, void * closure, PRUint32 count, PRUint32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void Search (in string forString, in boolean ignoreCase, out boolean found, out unsigned long offsetSearchedTo); */
NS_IMETHODIMP nsBufferInputStream::Search(const char *forString, PRBool ignoreCase, PRBool *found, PRUint32 *offsetSearchedTo)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute boolean NonBlocking; */
NS_IMETHODIMP nsBufferInputStream::GetNonBlocking(PRBool *aNonBlocking)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsBufferInputStream::SetNonBlocking(PRBool aNonBlocking)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIBufferInputStream_h__ */
