/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIJARURI.idl
 */

#ifndef __gen_nsIJARURI_h__
#define __gen_nsIJARURI_h__

#include "nsIURI.h"


/* starting interface:    nsIJARURI */
#define NS_IJARURI_IID_STR "c7e410d3-85f2-11d3-9f63-006008a6efe9"

#define NS_IJARURI_IID \
  {0xc7e410d3, 0x85f2, 0x11d3, \
    { 0x9f, 0x63, 0x00, 0x60, 0x08, 0xa6, 0xef, 0xe9 }}

/**
 * JAR URLs have the following syntax
 *
 * jar:<jar-file-uri>!/<jar-entry>
 *
 * EXAMPLE: jar:http://www.big.com/blue.jar!/ocean.html
 */
class nsIJARURI : public nsIURI {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IJARURI_IID)

  /**
     * Returns the root URI (the one for the actual JAR file) for this JAR.
     * eg http://www.big.com/blue.jar
     */
  /* attribute nsIURI JARFile; */
  NS_IMETHOD GetJARFile(nsIURI * *aJARFile) = 0;
  NS_IMETHOD SetJARFile(nsIURI * aJARFile) = 0;

  /**
     * Returns the entry specified for this JAR URI.
     * eg ocean.html
     */
  /* attribute string JAREntry; */
  NS_IMETHOD GetJAREntry(char * *aJAREntry) = 0;
  NS_IMETHOD SetJAREntry(const char * aJAREntry) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIJARURI \
  NS_IMETHOD GetJARFile(nsIURI * *aJARFile); \
  NS_IMETHOD SetJARFile(nsIURI * aJARFile); \
  NS_IMETHOD GetJAREntry(char * *aJAREntry); \
  NS_IMETHOD SetJAREntry(const char * aJAREntry); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIJARURI(_to) \
  NS_IMETHOD GetJARFile(nsIURI * *aJARFile) { return _to ## GetJARFile(aJARFile); } \
  NS_IMETHOD SetJARFile(nsIURI * aJARFile) { return _to ## SetJARFile(aJARFile); } \
  NS_IMETHOD GetJAREntry(char * *aJAREntry) { return _to ## GetJAREntry(aJAREntry); } \
  NS_IMETHOD SetJAREntry(const char * aJAREntry) { return _to ## SetJAREntry(aJAREntry); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsJARURI : public nsIJARURI
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIJARURI

  nsJARURI();
  virtual ~nsJARURI();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsJARURI, nsIJARURI)

nsJARURI::nsJARURI()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsJARURI::~nsJARURI()
{
  /* destructor code */
}

/* attribute nsIURI JARFile; */
NS_IMETHODIMP nsJARURI::GetJARFile(nsIURI * *aJARFile)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsJARURI::SetJARFile(nsIURI * aJARFile)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute string JAREntry; */
NS_IMETHODIMP nsJARURI::GetJAREntry(char * *aJAREntry)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsJARURI::SetJAREntry(const char * aJAREntry)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIJARURI_h__ */
