/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIJVMManager.idl
 */

#ifndef __gen_nsIJVMManager_h__
#define __gen_nsIJVMManager_h__

#include "nsISupports.h"

#ifndef JNI_H
#include "jni.h"
#endif
/*
 Java VM Plugin Manager
 This interface defines additional entry points that are available
 to JVM plugins for browsers that support JVM plugins.
*/
/*
#define NS_IJVMMANAGER_IID                           \
{ / * a1e5ed50-aa4a-11d1-85b2-00805f0e4dfe * /       \
    0xa1e5ed50,                                      \
    0xaa4a,                                          \
    0x11d1,                                          \
    {0x85, 0xb2, 0x00, 0x80, 0x5f, 0x0e, 0x4d, 0xfe} \
}
*/
#define NS_JVMMANAGER_CID                            \
{ /* 38e7ef10-58df-11d2-8164-006008119d7a */         \
    0x38e7ef10,                                      \
    0x58df,                                          \
    0x11d2,                                          \
    {0x81, 0x64, 0x00, 0x60, 0x08, 0x11, 0x9d, 0x7a} \
}
class nsIJVMPlugin; /* forward declaration */

class nsISecureEnv; /* forward declaration */


/* starting interface:    nsIJVMManager */
#define NS_IJVMMANAGER_IID_STR "a1e5ed50-aa4a-11d1-85b2-00805f0e4dfe"

#define NS_IJVMMANAGER_IID \
  {0xa1e5ed50, 0xaa4a, 0x11d1, \
    { 0x85, 0xb2, 0x00, 0x80, 0x5f, 0x0e, 0x4d, 0xfe }}

class nsIJVMManager : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IJVMMANAGER_IID)

      //	NS_DEFINE_STATIC_IID_ACCESSOR(NS_IJVMMANAGER_IID)
	NS_DEFINE_STATIC_CID_ACCESSOR(NS_JVMMANAGER_CID)
  /**
     * Creates a proxy JNI with an optional secure environment (which can be NULL).
     * There is a one-to-one correspondence between proxy JNIs and threads, so
     * calling this method multiple times from the same thread will return
     * the same proxy JNI.
     */
  /* [noscript] void CreateProxyJNI (in nsISecureEnv secureEnv, out JNIEnv outProxyEnv); */
  NS_IMETHOD CreateProxyJNI(nsISecureEnv *secureEnv, JNIEnv * *outProxyEnv) = 0;

  /**
	 * Returns the proxy JNI associated with the current thread, or NULL if no
	 * such association exists.
	 */
  /* [noscript] void GetProxyJNI (out JNIEnv outProxyEnv); */
  NS_IMETHOD GetProxyJNI(JNIEnv * *outProxyEnv) = 0;

  /**
	 * Returns whether or not Java is enabled.
	 */
  /* void IsJavaEnabled (out boolean outEnabled); */
  NS_IMETHOD IsJavaEnabled(PRBool *outEnabled) = 0;

  /**
	 * Called from Java Console menu item.
	 */
  /* void ShowJavaConsole (); */
  NS_IMETHOD ShowJavaConsole(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIJVMMANAGER \
  NS_IMETHOD CreateProxyJNI(nsISecureEnv *secureEnv, JNIEnv * *outProxyEnv); \
  NS_IMETHOD GetProxyJNI(JNIEnv * *outProxyEnv); \
  NS_IMETHOD IsJavaEnabled(PRBool *outEnabled); \
  NS_IMETHOD ShowJavaConsole(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIJVMMANAGER(_to) \
  NS_IMETHOD CreateProxyJNI(nsISecureEnv *secureEnv, JNIEnv * *outProxyEnv) { return _to ## CreateProxyJNI(secureEnv, outProxyEnv); } \
  NS_IMETHOD GetProxyJNI(JNIEnv * *outProxyEnv) { return _to ## GetProxyJNI(outProxyEnv); } \
  NS_IMETHOD IsJavaEnabled(PRBool *outEnabled) { return _to ## IsJavaEnabled(outEnabled); } \
  NS_IMETHOD ShowJavaConsole(void) { return _to ## ShowJavaConsole(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsJVMManager : public nsIJVMManager
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIJVMMANAGER

  nsJVMManager();
  virtual ~nsJVMManager();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsJVMManager, nsIJVMManager)

nsJVMManager::nsJVMManager()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsJVMManager::~nsJVMManager()
{
  /* destructor code */
}

/* [noscript] void CreateProxyJNI (in nsISecureEnv secureEnv, out JNIEnv outProxyEnv); */
NS_IMETHODIMP nsJVMManager::CreateProxyJNI(nsISecureEnv *secureEnv, JNIEnv * *outProxyEnv)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] void GetProxyJNI (out JNIEnv outProxyEnv); */
NS_IMETHODIMP nsJVMManager::GetProxyJNI(JNIEnv * *outProxyEnv)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void IsJavaEnabled (out boolean outEnabled); */
NS_IMETHODIMP nsJVMManager::IsJavaEnabled(PRBool *outEnabled)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void ShowJavaConsole (); */
NS_IMETHODIMP nsJVMManager::ShowJavaConsole()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIJVMManager_h__ */
