/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIProfile.idl
 */

#ifndef __gen_nsIProfile_h__
#define __gen_nsIProfile_h__

#include "nsISupports.h"

class nsICmdLineService; /* forward declaration */

class nsIFileSpec; /* forward declaration */

#include "nsFileSpec.h"
#include "nsICmdLineService.h"
      
#define NS_PROFILE_CID                                 \
  { /* {02b0625b-e7f3-11d2-9f5a-006008a6efe9} */       \
    0x02b0625b,                                        \
    0xe7f3,                                            \
    0x11d2,                                            \
    { 0x9f, 0x5a, 0x00, 0x60, 0x08, 0xa6, 0xef, 0xe9 } \
  }
#define NS_PROFILE_PROGID	\
	"component://netscape/profile/manager"
#define NS_PROFILE_STARTUP_CATEGORY \
        "profile-startup-category"

/* starting interface:    nsIProfile */
#define NS_IPROFILE_IID_STR "02b0625a-e7f3-11d2-9f5a-006008a6efe9"

#define NS_IPROFILE_IID \
  {0x02b0625a, 0xe7f3, 0x11d2, \
    { 0x9f, 0x5a, 0x00, 0x60, 0x08, 0xa6, 0xef, 0xe9 }}

class nsIProfile : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IPROFILE_IID)

  /* [noscript] void startupWithArgs (in nsICmdLineService cmdLine); */
  NS_IMETHOD StartupWithArgs(nsICmdLineService *cmdLine) = 0;

  /* void startup (in wstring filename); */
  NS_IMETHOD Startup(const PRUnichar *filename) = 0;

  /* [noscript] void getProfileDir (in wstring profileName, in nsFileSpec profileDir); */
  NS_IMETHOD GetProfileDir(const PRUnichar *profileName, nsFileSpec * profileDir) = 0;

  /* readonly attribute long profileCount; */
  NS_IMETHOD GetProfileCount(PRInt32 *aProfileCount) = 0;

  /* readonly attribute wstring currentProfile; */
  NS_IMETHOD GetCurrentProfile(PRUnichar * *aCurrentProfile) = 0;

  /* readonly attribute wstring firstProfile; */
  NS_IMETHOD GetFirstProfile(PRUnichar * *aFirstProfile) = 0;

  /* [noscript] void getCurrentProfileDir (in nsFileSpec profileDir); */
  NS_IMETHOD GetCurrentProfileDir(nsFileSpec * profileDir) = 0;

  /* [noscript] void setProfileDir (in wstring profileName, in nsFileSpecRef profileDir); */
  NS_IMETHOD SetProfileDir(const PRUnichar *profileName, nsFileSpec & profileDir) = 0;

  /* boolean profileExists (in wstring profileName); */
  NS_IMETHOD ProfileExists(const PRUnichar *profileName, PRBool *_retval) = 0;

  /* void migrateProfileInfo (); */
  NS_IMETHOD MigrateProfileInfo(void) = 0;

  /* void createNewProfile (in wstring profileName, in wstring nativeProfileDir, in wstring langcode, in boolean useExistingDir); */
  NS_IMETHOD CreateNewProfile(const PRUnichar *profileName, const PRUnichar *nativeProfileDir, const PRUnichar *langcode, PRBool useExistingDir) = 0;

  /* void renameProfile (in wstring oldName, in wstring newName); */
  NS_IMETHOD RenameProfile(const PRUnichar *oldName, const PRUnichar *newName) = 0;

  /* void deleteProfile (in wstring name, in boolean canDeleteFiles); */
  NS_IMETHOD DeleteProfile(const PRUnichar *name, PRBool canDeleteFiles) = 0;

  /* wstring getProfileList (); */
  NS_IMETHOD GetProfileList(PRUnichar **_retval) = 0;

  /* void startApprunner (in wstring profileName); */
  NS_IMETHOD StartApprunner(const PRUnichar *profileName) = 0;

  /* void migrateProfile (in wstring profileName, in boolean showProgressAsModalWindow); */
  NS_IMETHOD MigrateProfile(const PRUnichar *profileName, PRBool showProgressAsModalWindow) = 0;

  /* long get4xProfileCount (); */
  NS_IMETHOD Get4xProfileCount(PRInt32 *_retval) = 0;

  /* void migrateAllProfiles (); */
  NS_IMETHOD MigrateAllProfiles(void) = 0;

  /* void cloneProfile (in wstring profileName); */
  NS_IMETHOD CloneProfile(const PRUnichar *profileName) = 0;

  /* void forgetCurrentProfile (); */
  NS_IMETHOD ForgetCurrentProfile(void) = 0;

  /* void loadNewProfilePrefs (); */
  NS_IMETHOD LoadNewProfilePrefs(void) = 0;

  /* boolean isCurrentProfileAvailable (); */
  NS_IMETHOD IsCurrentProfileAvailable(PRBool *_retval) = 0;

  /* attribute boolean automigrate; */
  NS_IMETHOD GetAutomigrate(PRBool *aAutomigrate) = 0;
  NS_IMETHOD SetAutomigrate(PRBool aAutomigrate) = 0;

  /* readonly attribute nsIFileSpec defaultProfileParentDir; */
  NS_IMETHOD GetDefaultProfileParentDir(nsIFileSpec * *aDefaultProfileParentDir) = 0;

  /* void updateRegistry (); */
  NS_IMETHOD UpdateRegistry(void) = 0;

  /* void setRegStrings (in wstring profileName, in wstring regString, in wstring regName, in wstring regEmail, in wstring regOption); */
  NS_IMETHOD SetRegStrings(const PRUnichar *profileName, const PRUnichar *regString, const PRUnichar *regName, const PRUnichar *regEmail, const PRUnichar *regOption) = 0;

  /* string isRegStringSet (in wstring profileName); */
  NS_IMETHOD IsRegStringSet(const PRUnichar *profileName, char **_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPROFILE \
  NS_IMETHOD StartupWithArgs(nsICmdLineService *cmdLine); \
  NS_IMETHOD Startup(const PRUnichar *filename); \
  NS_IMETHOD GetProfileDir(const PRUnichar *profileName, nsFileSpec * profileDir); \
  NS_IMETHOD GetProfileCount(PRInt32 *aProfileCount); \
  NS_IMETHOD GetCurrentProfile(PRUnichar * *aCurrentProfile); \
  NS_IMETHOD GetFirstProfile(PRUnichar * *aFirstProfile); \
  NS_IMETHOD GetCurrentProfileDir(nsFileSpec * profileDir); \
  NS_IMETHOD SetProfileDir(const PRUnichar *profileName, nsFileSpec & profileDir); \
  NS_IMETHOD ProfileExists(const PRUnichar *profileName, PRBool *_retval); \
  NS_IMETHOD MigrateProfileInfo(void); \
  NS_IMETHOD CreateNewProfile(const PRUnichar *profileName, const PRUnichar *nativeProfileDir, const PRUnichar *langcode, PRBool useExistingDir); \
  NS_IMETHOD RenameProfile(const PRUnichar *oldName, const PRUnichar *newName); \
  NS_IMETHOD DeleteProfile(const PRUnichar *name, PRBool canDeleteFiles); \
  NS_IMETHOD GetProfileList(PRUnichar **_retval); \
  NS_IMETHOD StartApprunner(const PRUnichar *profileName); \
  NS_IMETHOD MigrateProfile(const PRUnichar *profileName, PRBool showProgressAsModalWindow); \
  NS_IMETHOD Get4xProfileCount(PRInt32 *_retval); \
  NS_IMETHOD MigrateAllProfiles(void); \
  NS_IMETHOD CloneProfile(const PRUnichar *profileName); \
  NS_IMETHOD ForgetCurrentProfile(void); \
  NS_IMETHOD LoadNewProfilePrefs(void); \
  NS_IMETHOD IsCurrentProfileAvailable(PRBool *_retval); \
  NS_IMETHOD GetAutomigrate(PRBool *aAutomigrate); \
  NS_IMETHOD SetAutomigrate(PRBool aAutomigrate); \
  NS_IMETHOD GetDefaultProfileParentDir(nsIFileSpec * *aDefaultProfileParentDir); \
  NS_IMETHOD UpdateRegistry(void); \
  NS_IMETHOD SetRegStrings(const PRUnichar *profileName, const PRUnichar *regString, const PRUnichar *regName, const PRUnichar *regEmail, const PRUnichar *regOption); \
  NS_IMETHOD IsRegStringSet(const PRUnichar *profileName, char **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPROFILE(_to) \
  NS_IMETHOD StartupWithArgs(nsICmdLineService *cmdLine) { return _to ## StartupWithArgs(cmdLine); } \
  NS_IMETHOD Startup(const PRUnichar *filename) { return _to ## Startup(filename); } \
  NS_IMETHOD GetProfileDir(const PRUnichar *profileName, nsFileSpec * profileDir) { return _to ## GetProfileDir(profileName, profileDir); } \
  NS_IMETHOD GetProfileCount(PRInt32 *aProfileCount) { return _to ## GetProfileCount(aProfileCount); } \
  NS_IMETHOD GetCurrentProfile(PRUnichar * *aCurrentProfile) { return _to ## GetCurrentProfile(aCurrentProfile); } \
  NS_IMETHOD GetFirstProfile(PRUnichar * *aFirstProfile) { return _to ## GetFirstProfile(aFirstProfile); } \
  NS_IMETHOD GetCurrentProfileDir(nsFileSpec * profileDir) { return _to ## GetCurrentProfileDir(profileDir); } \
  NS_IMETHOD SetProfileDir(const PRUnichar *profileName, nsFileSpec & profileDir) { return _to ## SetProfileDir(profileName, profileDir); } \
  NS_IMETHOD ProfileExists(const PRUnichar *profileName, PRBool *_retval) { return _to ## ProfileExists(profileName, _retval); } \
  NS_IMETHOD MigrateProfileInfo(void) { return _to ## MigrateProfileInfo(); } \
  NS_IMETHOD CreateNewProfile(const PRUnichar *profileName, const PRUnichar *nativeProfileDir, const PRUnichar *langcode, PRBool useExistingDir) { return _to ## CreateNewProfile(profileName, nativeProfileDir, langcode, useExistingDir); } \
  NS_IMETHOD RenameProfile(const PRUnichar *oldName, const PRUnichar *newName) { return _to ## RenameProfile(oldName, newName); } \
  NS_IMETHOD DeleteProfile(const PRUnichar *name, PRBool canDeleteFiles) { return _to ## DeleteProfile(name, canDeleteFiles); } \
  NS_IMETHOD GetProfileList(PRUnichar **_retval) { return _to ## GetProfileList(_retval); } \
  NS_IMETHOD StartApprunner(const PRUnichar *profileName) { return _to ## StartApprunner(profileName); } \
  NS_IMETHOD MigrateProfile(const PRUnichar *profileName, PRBool showProgressAsModalWindow) { return _to ## MigrateProfile(profileName, showProgressAsModalWindow); } \
  NS_IMETHOD Get4xProfileCount(PRInt32 *_retval) { return _to ## Get4xProfileCount(_retval); } \
  NS_IMETHOD MigrateAllProfiles(void) { return _to ## MigrateAllProfiles(); } \
  NS_IMETHOD CloneProfile(const PRUnichar *profileName) { return _to ## CloneProfile(profileName); } \
  NS_IMETHOD ForgetCurrentProfile(void) { return _to ## ForgetCurrentProfile(); } \
  NS_IMETHOD LoadNewProfilePrefs(void) { return _to ## LoadNewProfilePrefs(); } \
  NS_IMETHOD IsCurrentProfileAvailable(PRBool *_retval) { return _to ## IsCurrentProfileAvailable(_retval); } \
  NS_IMETHOD GetAutomigrate(PRBool *aAutomigrate) { return _to ## GetAutomigrate(aAutomigrate); } \
  NS_IMETHOD SetAutomigrate(PRBool aAutomigrate) { return _to ## SetAutomigrate(aAutomigrate); } \
  NS_IMETHOD GetDefaultProfileParentDir(nsIFileSpec * *aDefaultProfileParentDir) { return _to ## GetDefaultProfileParentDir(aDefaultProfileParentDir); } \
  NS_IMETHOD UpdateRegistry(void) { return _to ## UpdateRegistry(); } \
  NS_IMETHOD SetRegStrings(const PRUnichar *profileName, const PRUnichar *regString, const PRUnichar *regName, const PRUnichar *regEmail, const PRUnichar *regOption) { return _to ## SetRegStrings(profileName, regString, regName, regEmail, regOption); } \
  NS_IMETHOD IsRegStringSet(const PRUnichar *profileName, char **_retval) { return _to ## IsRegStringSet(profileName, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsProfile : public nsIProfile
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPROFILE

  nsProfile();
  virtual ~nsProfile();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsProfile, nsIProfile)

nsProfile::nsProfile()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsProfile::~nsProfile()
{
  /* destructor code */
}

/* [noscript] void startupWithArgs (in nsICmdLineService cmdLine); */
NS_IMETHODIMP nsProfile::StartupWithArgs(nsICmdLineService *cmdLine)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void startup (in wstring filename); */
NS_IMETHODIMP nsProfile::Startup(const PRUnichar *filename)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] void getProfileDir (in wstring profileName, in nsFileSpec profileDir); */
NS_IMETHODIMP nsProfile::GetProfileDir(const PRUnichar *profileName, nsFileSpec * profileDir)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long profileCount; */
NS_IMETHODIMP nsProfile::GetProfileCount(PRInt32 *aProfileCount)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring currentProfile; */
NS_IMETHODIMP nsProfile::GetCurrentProfile(PRUnichar * *aCurrentProfile)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring firstProfile; */
NS_IMETHODIMP nsProfile::GetFirstProfile(PRUnichar * *aFirstProfile)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] void getCurrentProfileDir (in nsFileSpec profileDir); */
NS_IMETHODIMP nsProfile::GetCurrentProfileDir(nsFileSpec * profileDir)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] void setProfileDir (in wstring profileName, in nsFileSpecRef profileDir); */
NS_IMETHODIMP nsProfile::SetProfileDir(const PRUnichar *profileName, nsFileSpec & profileDir)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean profileExists (in wstring profileName); */
NS_IMETHODIMP nsProfile::ProfileExists(const PRUnichar *profileName, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void migrateProfileInfo (); */
NS_IMETHODIMP nsProfile::MigrateProfileInfo()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void createNewProfile (in wstring profileName, in wstring nativeProfileDir, in wstring langcode, in boolean useExistingDir); */
NS_IMETHODIMP nsProfile::CreateNewProfile(const PRUnichar *profileName, const PRUnichar *nativeProfileDir, const PRUnichar *langcode, PRBool useExistingDir)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void renameProfile (in wstring oldName, in wstring newName); */
NS_IMETHODIMP nsProfile::RenameProfile(const PRUnichar *oldName, const PRUnichar *newName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void deleteProfile (in wstring name, in boolean canDeleteFiles); */
NS_IMETHODIMP nsProfile::DeleteProfile(const PRUnichar *name, PRBool canDeleteFiles)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* wstring getProfileList (); */
NS_IMETHODIMP nsProfile::GetProfileList(PRUnichar **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void startApprunner (in wstring profileName); */
NS_IMETHODIMP nsProfile::StartApprunner(const PRUnichar *profileName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void migrateProfile (in wstring profileName, in boolean showProgressAsModalWindow); */
NS_IMETHODIMP nsProfile::MigrateProfile(const PRUnichar *profileName, PRBool showProgressAsModalWindow)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long get4xProfileCount (); */
NS_IMETHODIMP nsProfile::Get4xProfileCount(PRInt32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void migrateAllProfiles (); */
NS_IMETHODIMP nsProfile::MigrateAllProfiles()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void cloneProfile (in wstring profileName); */
NS_IMETHODIMP nsProfile::CloneProfile(const PRUnichar *profileName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void forgetCurrentProfile (); */
NS_IMETHODIMP nsProfile::ForgetCurrentProfile()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void loadNewProfilePrefs (); */
NS_IMETHODIMP nsProfile::LoadNewProfilePrefs()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isCurrentProfileAvailable (); */
NS_IMETHODIMP nsProfile::IsCurrentProfileAvailable(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute boolean automigrate; */
NS_IMETHODIMP nsProfile::GetAutomigrate(PRBool *aAutomigrate)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsProfile::SetAutomigrate(PRBool aAutomigrate)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIFileSpec defaultProfileParentDir; */
NS_IMETHODIMP nsProfile::GetDefaultProfileParentDir(nsIFileSpec * *aDefaultProfileParentDir)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void updateRegistry (); */
NS_IMETHODIMP nsProfile::UpdateRegistry()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setRegStrings (in wstring profileName, in wstring regString, in wstring regName, in wstring regEmail, in wstring regOption); */
NS_IMETHODIMP nsProfile::SetRegStrings(const PRUnichar *profileName, const PRUnichar *regString, const PRUnichar *regName, const PRUnichar *regEmail, const PRUnichar *regOption)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* string isRegStringSet (in wstring profileName); */
NS_IMETHODIMP nsProfile::IsRegStringSet(const PRUnichar *profileName, char **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIProfile_h__ */
