/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIRefreshURI.idl
 */

#ifndef __gen_nsIRefreshURI_h__
#define __gen_nsIRefreshURI_h__

#include "nsISupports.h"
#include "nsIURI.h"


/* starting interface:    nsIRefreshURI */
#define NS_IREFRESHURI_IID_STR "69efc430-2efe-11d2-9e5d-006008bf092e"

#define NS_IREFRESHURI_IID \
  {0x69efc430, 0x2efe, 0x11d2, \
    { 0x9e, 0x5d, 0x00, 0x60, 0x08, 0xbf, 0x09, 0x2e }}

class nsIRefreshURI : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IREFRESHURI_IID)

  /**
      * Reloads a uri after waiting millis milliseconds.
      *
      * @param uri The uri to refresh.
      * @param millis The number of milliseconds to wait.
      * @param repeat Do you want the uri to be repeatedly refreshed every millis milliseconds.
      */
  /* void refreshURI (in nsIURI aURI, in long aMillis, in boolean aRepeat); */
  NS_IMETHOD RefreshURI(nsIURI *aURI, PRInt32 aMillis, PRBool aRepeat) = 0;

  /**
      * Cancels all timer loads.
      */
  /* void cancelRefreshURITimers (); */
  NS_IMETHOD CancelRefreshURITimers(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIREFRESHURI \
  NS_IMETHOD RefreshURI(nsIURI *aURI, PRInt32 aMillis, PRBool aRepeat); \
  NS_IMETHOD CancelRefreshURITimers(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIREFRESHURI(_to) \
  NS_IMETHOD RefreshURI(nsIURI *aURI, PRInt32 aMillis, PRBool aRepeat) { return _to ## RefreshURI(aURI, aMillis, aRepeat); } \
  NS_IMETHOD CancelRefreshURITimers(void) { return _to ## CancelRefreshURITimers(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsRefreshURI : public nsIRefreshURI
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIREFRESHURI

  nsRefreshURI();
  virtual ~nsRefreshURI();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsRefreshURI, nsIRefreshURI)

nsRefreshURI::nsRefreshURI()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsRefreshURI::~nsRefreshURI()
{
  /* destructor code */
}

/* void refreshURI (in nsIURI aURI, in long aMillis, in boolean aRepeat); */
NS_IMETHODIMP nsRefreshURI::RefreshURI(nsIURI *aURI, PRInt32 aMillis, PRBool aRepeat)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void cancelRefreshURITimers (); */
NS_IMETHODIMP nsRefreshURI::CancelRefreshURITimers()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIRefreshURI_h__ */
